searchNodes=[{"doc":"Config struct. Keys :session_ttl , :refresh_token_ttl and :session_store_module have no defaults and are mandatory. Setting :session_ttl to nil means sessions can live forever, as long as they are refreshed. The token salts serve to separate one token from another, the real secret is the endpoint's secret key base. Defaults: % Config { :refresh_token_ttl , # max age of a refresh token :session_store_module , # an implementation of YipyipExAuth.SessionStore :session_ttl , # max age of a session, nil is infinite access_token_ttl : 1800 , # max age of an access token access_token_salt : &quot;access_token&quot; , # &quot;namespace&quot; of the access token refresh_token_salt : &quot;refresh_token&quot; , # &quot;namespace&quot; of the refresh token access_token_key_digest : :sha256 , # hashing algorithm of the access token refresh_token_key_digest : :sha512 , # hashing algorithm of the refresh token access_cookie_name : &quot;_access_token_signature&quot; , # name of the access token&#39;s signature cookie refresh_cookie_name : &quot;_refresh_token_signature&quot; , # name of the refresh token&#39;s signature cookie access_cookie_opts : [ # access cookie opts for Plug.Conn.put_resp_cookie/4 http_only : true , extra : &quot;SameSite=Strict&quot; , secure : true ] , refresh_cookie_opts : [ # refresh cookie opts for Plug.Conn.put_resp_cookie/4 http_only : true , extra : &quot;SameSite=Strict&quot; , secure : true ] }","ref":"YipyipExAuth.Config.html","title":"YipyipExAuth.Config","type":"module"},{"doc":"Build config struct from enumerable (useful for passing in application environment). Raises for missing mandatory keys and sets defaults for optional keys. Examples / doctests iex&gt; from_enum ( [ ] ) ** (ArgumentError) the following keys must also be given when building struct YipyipExAuth.Config: [:session_ttl, :refresh_token_ttl, :session_store_module] iex&gt; % YipyipExAuth.Config { } = from_enum ( [ session_ttl : 30 * 24 * 60 * 60 , refresh_token_ttl : 24 * 60 * 60 , session_store_module : MyModule ] )","ref":"YipyipExAuth.Config.html#from_enum/1","title":"YipyipExAuth.Config.from_enum/1","type":"function"},{"doc":"","ref":"YipyipExAuth.Config.html#t:t/0","title":"YipyipExAuth.Config.t/0","type":"type"},{"doc":"A session.","ref":"YipyipExAuth.Models.Session.html","title":"YipyipExAuth.Models.Session","type":"module"},{"doc":"Create a new session struct from an old session struct.","ref":"YipyipExAuth.Models.Session.html#upgrade_old_session/1","title":"YipyipExAuth.Models.Session.upgrade_old_session/1","type":"function"},{"doc":"","ref":"YipyipExAuth.Models.Session.html#t:t/0","title":"YipyipExAuth.Models.Session.t/0","type":"type"},{"doc":"Tokens to be communicated to the client.","ref":"YipyipExAuth.Models.Tokens.html","title":"YipyipExAuth.Models.Tokens","type":"module"},{"doc":"","ref":"YipyipExAuth.Models.Tokens.html#t:t/0","title":"YipyipExAuth.Models.Tokens.t/0","type":"type"},{"doc":"Function plugs to create and delete sessions. upsert_session/3 can be used in combination with YipyipExAuth.Plugs.ProcessRefreshToken for token refreshing.","ref":"YipyipExAuth.Plugs.html","title":"YipyipExAuth.Plugs","type":"module"},{"doc":"Create or update a session. If a session exists in the conn, the session is updated, otherwise a new one is created. The session is put on the conn by YipyipExAuth.Plugs.ProcessRefreshToken . In both cases, new access / refresh tokens are created and stored in the conn's private map. The server-side session stored in the session store is created / updated as well. If a new session is created, this plug must be preceded by YipyipExAuth.Utils.set_token_signature_transport/2 and YipyipExAuth.Utils.set_user_id/2 or an error will be raised. The tokens' signatures are split off and sent as cookies if the session's token signature transport mechanism is set to :cookie . By default, these are http-only strictly-same-site secure cookies. Optionally, it is possible to store extra payload in the access- and refresh tokens, which can be used to implement things like role-based authorization or forced logout after password change. Raises on session store errors. No recovery is possible from this error - the session HAS to be stored or there is no point in handing out tokens. Examples / doctests use YipyipExAuth.Utils.Constants alias Plug.Conn alias YipyipExAuth.Utils alias YipyipExAuth.Models . { Session , Tokens } import YipyipExAuth.Plugs # only available when Mix env = test alias YipyipExAuth.TestSupport.FakeSessionStore import YipyipExAuth.TestSupport.Shared @config YipyipExAuth.Config . from_enum ( session_ttl : 68400 , refresh_token_ttl : 3600 , session_store_module : FakeSessionStore ) # error if user id not set for new session iex&gt; % Conn { } |&gt; Utils . set_token_signature_transport ( :bearer ) |&gt; create_session ( @config ) ** (RuntimeError) Set user id using Utils.set_user_id/2 # error if signature transport not set for new session iex&gt; % Conn { } |&gt; Utils . set_user_id ( 1 ) |&gt; create_session ( @config ) ** (RuntimeError) Set token signature transport using Utils.set_token_signature_transport/2 # creates session if none present in conn iex&gt; conn = build_conn ( ) ...&gt; |&gt; Utils . set_user_id ( 1 ) ...&gt; |&gt; Utils . set_token_signature_transport ( :cookie ) ...&gt; |&gt; create_session ( @config ) iex&gt; % Session { } = Utils . get_session ( conn ) iex&gt; % Tokens { } = Utils . get_tokens ( conn ) # renews session if present in conn, updating only refresh_token_id, refreshed_at and last_known_ip # existing session&#39;s user id or signature transport will not change despite attempted override iex&gt; old_session = % Session { token_signature_transport : :bearer , user_id : 43 } iex&gt; conn = build_conn ( ) ...&gt; |&gt; Conn . put_private ( @private_session_key , old_session ) ...&gt; |&gt; Utils . set_token_signature_transport ( :cookie ) ...&gt; |&gt; Utils . set_user_id ( 1 ) ...&gt; |&gt; create_session ( @config ) iex&gt; session = Utils . get_session ( conn ) |&gt; Map . from_struct ( ) iex&gt; old_session = Map . from_struct ( old_session ) iex&gt; Enum . map ( ~w(id user_id created_at expires_at token_signature_transport)a , &amp; session [ &amp;1 ] == old_session [ &amp;1 ] ) [ true , true , true , true , true ] iex&gt; Enum . map ( ~w(refresh_token_id refreshed_at last_known_ip)a , &amp; session [ &amp;1 ] == old_session [ &amp;1 ] ) [ false , false , false ] # returns signatures in cookies if requested, which removes signatures from tokens iex&gt; conn = build_conn ( ) ...&gt; |&gt; Utils . set_token_signature_transport ( :cookie ) ...&gt; |&gt; Utils . set_user_id ( 1 ) ...&gt; |&gt; create_session ( @config ) iex&gt; cookies = conn |&gt; Conn . fetch_cookies ( ) |&gt; Map . get ( :cookies ) iex&gt; &lt;&lt; _access_sig :: binary &gt;&gt; = Map . get ( cookies , @config . access_cookie_name ) iex&gt; &lt;&lt; _refresh_sig :: binary &gt;&gt; = Map . get ( cookies , @config . refresh_cookie_name ) iex&gt; true = Regex . match? ( ~r/ \\w \\. \\w / , conn |&gt; Utils . get_tokens ( ) |&gt; Map . get ( :access_token ) ) iex&gt; true = Regex . match? ( ~r/ \\w \\. \\w / , conn |&gt; Utils . get_tokens ( ) |&gt; Map . get ( :refresh_token ) ) # allows adding extra payload to tokens iex&gt; conn = build_conn ( ) ...&gt; |&gt; Utils . set_token_signature_transport ( :bearer ) ...&gt; |&gt; Utils . set_user_id ( 1 ) ...&gt; |&gt; create_session ( @config , %{ much : :extra } , %{ really : true } ) iex&gt; %{ epl : %{ much : :extra } } = Utils . get_access_token_payload ( conn ) iex&gt; %{ epl : %{ really : true } } = Utils . get_refresh_token_payload ( conn )","ref":"YipyipExAuth.Plugs.html#create_session/4","title":"YipyipExAuth.Plugs.create_session/4","type":"function"},{"doc":"Delete the persistent session identified by the session_id in the access token payload. Note that the access token remains valid until it expires, it is left up to the client to drop the access token. It will no longer be possible to refresh the session, however. Examples / doctests # instructs browsers to clear signature cookies iex&gt; build_conn ( ) ...&gt; |&gt; Plug.Test . put_req_cookie ( @config . access_cookie_name , &quot;anything&quot; ) ...&gt; |&gt; Plug.Test . put_req_cookie ( @config . refresh_cookie_name , &quot;anything&quot; ) ...&gt; |&gt; delete_session ( @config ) ...&gt; |&gt; Conn . fetch_cookies ( ) ...&gt; |&gt; Map . get ( :cookies ) %{ }","ref":"YipyipExAuth.Plugs.html#delete_session/2","title":"YipyipExAuth.Plugs.delete_session/2","type":"function"},{"doc":"Create or update a session. If a session exists in the conn, the session is updated, otherwise a new one is created. The session is put on the conn by YipyipExAuth.Plugs.ProcessRefreshToken . In both cases, new access / refresh tokens are created and stored in the conn's private map. The server-side session stored in the session store is created / updated as well. If a new session is created, this plug must be preceded by YipyipExAuth.Utils.set_token_signature_transport/2 and YipyipExAuth.Utils.set_user_id/2 or an error will be raised. The tokens' signatures are split off and sent as cookies if the session's token signature transport mechanism is set to :cookie . By default, these are http-only strictly-same-site secure cookies. Optionally, it is possible to store extra payload in the access- and refresh tokens, which can be used to implement things like role-based authorization or forced logout after password change. Raises on session store errors. No recovery is possible from this error - the session HAS to be stored or there is no point in handing out tokens. Examples / doctests use YipyipExAuth.Utils.Constants alias Plug.Conn alias YipyipExAuth.Utils alias YipyipExAuth.Models . { Session , Tokens } import YipyipExAuth.Plugs # only available when Mix env = test alias YipyipExAuth.TestSupport.FakeSessionStore import YipyipExAuth.TestSupport.Shared @config YipyipExAuth.Config . from_enum ( session_ttl : 68400 , refresh_token_ttl : 3600 , session_store_module : FakeSessionStore ) # error if user id not set for new session iex&gt; % Conn { } |&gt; Utils . set_token_signature_transport ( :bearer ) |&gt; upsert_session ( @config ) ** (RuntimeError) Set user id using Utils.set_user_id/2 # error if signature transport not set for new session iex&gt; % Conn { } |&gt; Utils . set_user_id ( 1 ) |&gt; upsert_session ( @config ) ** (RuntimeError) Set token signature transport using Utils.set_token_signature_transport/2 # creates session if none present in conn iex&gt; conn = build_conn ( ) ...&gt; |&gt; Utils . set_user_id ( 1 ) ...&gt; |&gt; Utils . set_token_signature_transport ( :cookie ) ...&gt; |&gt; upsert_session ( @config ) iex&gt; % Session { } = Utils . get_session ( conn ) iex&gt; % Tokens { } = Utils . get_tokens ( conn ) # renews session if present in conn, updating only refresh_token_id, refreshed_at and last_known_ip # existing session&#39;s user id or signature transport will not change despite attempted override iex&gt; old_session = % Session { token_signature_transport : :bearer , user_id : 43 } iex&gt; conn = build_conn ( ) ...&gt; |&gt; Conn . put_private ( @private_session_key , old_session ) ...&gt; |&gt; Utils . set_token_signature_transport ( :cookie ) ...&gt; |&gt; Utils . set_user_id ( 1 ) ...&gt; |&gt; upsert_session ( @config ) iex&gt; session = Utils . get_session ( conn ) |&gt; Map . from_struct ( ) iex&gt; old_session = Map . from_struct ( old_session ) iex&gt; Enum . map ( ~w(id user_id created_at expires_at token_signature_transport)a , &amp; session [ &amp;1 ] == old_session [ &amp;1 ] ) [ true , true , true , true , true ] iex&gt; Enum . map ( ~w(refresh_token_id refreshed_at last_known_ip)a , &amp; session [ &amp;1 ] == old_session [ &amp;1 ] ) [ false , false , false ] # returns signatures in cookies if requested, which removes signatures from tokens iex&gt; conn = build_conn ( ) ...&gt; |&gt; Utils . set_token_signature_transport ( :cookie ) ...&gt; |&gt; Utils . set_user_id ( 1 ) ...&gt; |&gt; upsert_session ( @config ) iex&gt; cookies = conn |&gt; Conn . fetch_cookies ( ) |&gt; Map . get ( :cookies ) iex&gt; &lt;&lt; _access_sig :: binary &gt;&gt; = Map . get ( cookies , @config . access_cookie_name ) iex&gt; &lt;&lt; _refresh_sig :: binary &gt;&gt; = Map . get ( cookies , @config . refresh_cookie_name ) iex&gt; true = Regex . match? ( ~r/ \\w \\. \\w / , conn |&gt; Utils . get_tokens ( ) |&gt; Map . get ( :access_token ) ) iex&gt; true = Regex . match? ( ~r/ \\w \\. \\w / , conn |&gt; Utils . get_tokens ( ) |&gt; Map . get ( :refresh_token ) ) # allows adding extra payload to tokens iex&gt; conn = build_conn ( ) ...&gt; |&gt; Utils . set_token_signature_transport ( :bearer ) ...&gt; |&gt; Utils . set_user_id ( 1 ) ...&gt; |&gt; upsert_session ( @config , extra_access_payload : %{ much : :extra } , extra_refresh_payload : %{ really : true } ) iex&gt; %{ epl : %{ much : :extra } } = Utils . get_access_token_payload ( conn ) iex&gt; %{ epl : %{ really : true } } = Utils . get_refresh_token_payload ( conn ) # allows adding extra payload to session iex&gt; conn = build_conn ( ) ...&gt; |&gt; Utils . set_user_id ( 1 ) ...&gt; |&gt; Utils . set_token_signature_transport ( :cookie ) ...&gt; |&gt; upsert_session ( @config , extra_session_payload : %{ what? : &quot;that&#39;s right!&quot; } ) iex&gt; % Session { extra_payload : %{ what? : &quot;that&#39;s right!&quot; } } = Utils . get_session ( conn )","ref":"YipyipExAuth.Plugs.html#upsert_session/3","title":"YipyipExAuth.Plugs.upsert_session/3","type":"function"},{"doc":"","ref":"YipyipExAuth.Plugs.html#t:upsert_session_opts/0","title":"YipyipExAuth.Plugs.upsert_session_opts/0","type":"type"},{"doc":"Plug to process and verify access tokens. Must be initialized with a YipyipExAuth.Config -struct, which can be initialized itself using YipyipExAuth.Config.from_enum/1 . The plug does not reject unauthenticated requests by itself. If a request is successfully verified, the user ID, session ID and extra payload are assigned to the conn. If not, an authentication error message is put in the conn's private map, which can be retrieved using YipyipExAuth.Utils.get_auth_error/1 . This allows applications to implement their own plug to reject unauthenticated requests, for example: Usage example that rejects unauthenticated requests defmodule MyPhoenixAppWeb.Router do use MyPhoenixAppWeb , :router @config YipyipExAuth.Config . from_enum ( session_ttl : 68400 , refresh_token_ttl : 3600 , session_store_module : MyModule ) pipeline :valid_access_token do plug YipyipExAuth.Plugs.ProcessAccessToken , @config plug :only_authenticated end @doc &quot;&quot;&quot; Reject unauthenticated requests &quot;&quot;&quot; def only_authenticated ( %{ assigns : %{ current_user_id : _ } } = conn , _opts ) , do : conn def only_authenticated ( conn , _opts ) do auth_error = YipyipExAuth.Utils . get_auth_error ( conn ) conn |&gt; Plug.Conn . send_resp ( 401 , auth_error ) |&gt; halt ( ) end end In this way, applications can completely customize how to respond to unauthenticated requests and how much information to expose to the client. Examples / doctests alias Plug.Conn alias YipyipExAuth.Plugs.ProcessAccessToken alias YipyipExAuth.Utils import YipyipExAuth.TestHelpers # only available when Mix env = test alias YipyipExAuth.TestSupport.FakeSessionStore import YipyipExAuth.TestSupport.Shared @config YipyipExAuth.Config . from_enum ( session_ttl : 68400 , refresh_token_ttl : 3600 , session_store_module : FakeSessionStore ) @plug_opts ProcessAccessToken . init ( @config ) # &quot;reject&quot; requests without bearer token iex&gt; conn = % Conn { } |&gt; ProcessAccessToken . call ( @plug_opts ) iex&gt; &quot;bearer token not found&quot; = Utils . get_auth_error ( conn ) iex&gt; conn . assigns %{ } # &quot;reject&quot; requests with invalid token iex&gt; config = %{ @config | access_token_salt : &quot;different&quot; } iex&gt; conn = build_conn ( ) |&gt; put_access_token ( config ) |&gt; ProcessAccessToken . call ( @plug_opts ) iex&gt; &quot;bearer token invalid&quot; = Utils . get_auth_error ( conn ) iex&gt; conn . assigns %{ } # &quot;reject&quot; requests with expired bearer token iex&gt; plug_opts = ProcessAccessToken . init ( %{ @config | access_token_ttl : - 1 } ) iex&gt; conn = build_conn ( ) |&gt; put_access_token ( @config ) |&gt; ProcessAccessToken . call ( plug_opts ) iex&gt; &quot;bearer token expired&quot; = Utils . get_auth_error ( conn ) iex&gt; conn . assigns %{ } # &quot;reject&quot; requests where the signature transport mechanism does not match the session&#39;s initial value iex&gt; token = generate_access_token ( build_conn ( ) , @config , %{ tst : :cookie } ) iex&gt; conn = build_conn ( ) |&gt; put_access_token ( @config , token ) |&gt; ProcessAccessToken . call ( @plug_opts ) iex&gt; &quot;token signature transport invalid&quot; = Utils . get_auth_error ( conn ) iex&gt; conn . assigns %{ } # &quot;reject&quot; requests with an expired session iex&gt; token = generate_access_token ( build_conn ( ) , @config , %{ exp : 1 } ) iex&gt; conn = build_conn ( ) |&gt; put_access_token ( @config , token ) |&gt; ProcessAccessToken . call ( @plug_opts ) iex&gt; &quot;session expired&quot; = Utils . get_auth_error ( conn ) iex&gt; conn . assigns %{ } # &quot;allow&quot; requests with valid bearer token iex&gt; conn = build_conn ( ) |&gt; put_access_token ( @config ) |&gt; ProcessAccessToken . call ( @plug_opts ) iex&gt; nil = Utils . get_auth_error ( conn ) iex&gt; conn . assigns %{ current_session_id : &quot;a&quot; , current_user_id : 1 , extra_access_token_payload : %{ } } # &quot;allow&quot; requests with valid bearer token with signature in cookie iex&gt; token = generate_access_token ( build_conn ( ) , @config , %{ tst : :cookie } ) iex&gt; [ header , encoded_payload , signature ] = String . split ( token , &quot;.&quot; , parts : 3 ) iex&gt; conn = build_conn ( ) ...&gt; |&gt; put_access_token ( @config , header &lt;&gt; &quot;.&quot; &lt;&gt; encoded_payload ) ...&gt; |&gt; Plug.Test . put_req_cookie ( @config . access_cookie_name , &quot;.&quot; &lt;&gt; signature ) ...&gt; |&gt; ProcessAccessToken . call ( @plug_opts ) iex&gt; nil = Utils . get_auth_error ( conn ) iex&gt; conn . assigns %{ current_session_id : &quot;a&quot; , current_user_id : 1 , extra_access_token_payload : %{ } }","ref":"YipyipExAuth.Plugs.ProcessAccessToken.html","title":"YipyipExAuth.Plugs.ProcessAccessToken","type":"module"},{"doc":"Plug to process and verify refresh tokens. Must be initialized with a YipyipExAuth.Config -struct, which can be initialized itself using YipyipExAuth.Config.from_enum/1 . The token signature source (bearer or cookie) must match the token_signature_transport specified in the token payload. A refresh token can only be used to refresh a session once. A single refresh token id is stored in the server-side session by YipyipExAuth.Plugs.create_session/2 to enforce this. The plug does not reject unauthenticated requests by itself. If a request is successfully verified, the user ID, session ID and extra payload are assigned to the conn. If not, an authentication error message is put in the conn's private map, which can be retrieved using YipyipExAuth.Utils.get_auth_error/1 . This allows applications to implement their own plug to reject unauthenticated requests, for example: Usage example that rejects unauthenticated requests defmodule MyPhoenixAppWeb.Router do use MyPhoenixAppWeb , :router @config YipyipExAuth.Config . from_enum ( session_ttl : 68400 , refresh_token_ttl : 3600 , session_store_module : MyModule ) pipeline :valid_refresh_token do plug YipyipExAuth.Plugs.ProcessRefreshToken , @config plug :only_authenticated end @doc &quot;&quot;&quot; Reject unauthenticated requests &quot;&quot;&quot; def only_authenticated ( %{ assigns : %{ current_user_id : _ } } = conn , _opts ) , do : conn def only_authenticated ( conn , _opts ) do auth_error = YipyipExAuth.Utils . get_auth_error ( conn ) conn |&gt; Plug.Conn . send_resp ( 401 , auth_error ) |&gt; halt ( ) end end In this way, applications can completely customize how to respond to unauthenticated requests and how much information to expose to the client. Examples / doctests alias Plug.Conn alias YipyipExAuth.Plugs.ProcessRefreshToken alias YipyipExAuth.Utils import YipyipExAuth.TestHelpers # only available when Mix env = test alias YipyipExAuth.TestSupport.FakeSessionStore import YipyipExAuth.TestSupport.Shared @config YipyipExAuth.Config . from_enum ( session_ttl : 68400 , refresh_token_ttl : 3600 , session_store_module : FakeSessionStore ) @plug_opts ProcessRefreshToken . init ( @config ) # &quot;reject&quot; requests without refresh token iex&gt; conn = % Conn { } |&gt; ProcessRefreshToken . call ( @plug_opts ) iex&gt; &quot;refresh token not found&quot; = Utils . get_auth_error ( conn ) iex&gt; { conn . assigns , Utils . get_session ( conn ) } { %{ } , nil } # &quot;reject&quot; requests with invalid token iex&gt; config = %{ @config | refresh_token_salt : &quot;different&quot; } iex&gt; conn = build_conn ( ) |&gt; put_refresh_token ( config ) |&gt; ProcessRefreshToken . call ( @plug_opts ) iex&gt; &quot;refresh token invalid&quot; = Utils . get_auth_error ( conn ) iex&gt; { conn . assigns , Utils . get_session ( conn ) } { %{ } , nil } # &quot;reject&quot; requests with expired refresh token iex&gt; plug_opts = ProcessRefreshToken . init ( %{ @config | refresh_token_ttl : - 1 } ) iex&gt; conn = build_conn ( ) |&gt; put_refresh_token ( @config ) |&gt; ProcessRefreshToken . call ( plug_opts ) iex&gt; &quot;refresh token expired&quot; = Utils . get_auth_error ( conn ) iex&gt; { conn . assigns , Utils . get_session ( conn ) } { %{ } , nil } # &quot;reject&quot; requests where the signature transport mechanism does not match the session&#39;s initial value iex&gt; token = generate_refresh_token ( build_conn ( ) , @config , %{ tst : :cookie } ) iex&gt; conn = build_conn ( ) |&gt; put_refresh_token ( @config , token ) |&gt; ProcessRefreshToken . call ( @plug_opts ) iex&gt; &quot;token signature transport invalid&quot; = Utils . get_auth_error ( conn ) iex&gt; { conn . assigns , Utils . get_session ( conn ) } { %{ } , nil } # &quot;reject&quot; requests with an expired session iex&gt; token = generate_refresh_token ( build_conn ( ) , @config , %{ exp : 1 } ) iex&gt; conn = build_conn ( ) |&gt; put_refresh_token ( @config , token ) |&gt; ProcessRefreshToken . call ( @plug_opts ) iex&gt; &quot;session expired&quot; = Utils . get_auth_error ( conn ) iex&gt; { conn . assigns , Utils . get_session ( conn ) } { %{ } , nil } # &quot;allow&quot; requests with valid refresh token iex&gt; conn = build_conn ( ) |&gt; put_refresh_token ( @config ) |&gt; ProcessRefreshToken . call ( @plug_opts ) iex&gt; nil = Utils . get_auth_error ( conn ) iex&gt; conn . assigns %{ current_session_id : &quot;a&quot; , current_user_id : 1 , extra_refresh_token_payload : %{ } } iex&gt; % YipyipExAuth.Models.Session { } = Utils . get_session ( conn ) # &quot;allow&quot; requests with valid refresh token with signature in cookie iex&gt; token = generate_refresh_token ( build_conn ( ) , @config , %{ tst : :cookie } ) iex&gt; [ header , encoded_payload , signature ] = String . split ( token , &quot;.&quot; , parts : 3 ) iex&gt; conn = build_conn ( ) ...&gt; |&gt; put_refresh_token ( @config , header &lt;&gt; &quot;.&quot; &lt;&gt; encoded_payload ) ...&gt; |&gt; Plug.Test . put_req_cookie ( @config . refresh_cookie_name , &quot;.&quot; &lt;&gt; signature ) ...&gt; |&gt; ProcessRefreshToken . call ( @plug_opts ) iex&gt; nil = Utils . get_auth_error ( conn ) iex&gt; conn . assigns %{ current_session_id : &quot;a&quot; , current_user_id : 1 , extra_refresh_token_payload : %{ } } iex&gt; % YipyipExAuth.Models.Session { } = Utils . get_session ( conn )","ref":"YipyipExAuth.Plugs.ProcessRefreshToken.html","title":"YipyipExAuth.Plugs.ProcessRefreshToken","type":"module"},{"doc":"Behaviour definition of a persistent session store, to be implemented by the application. The implementation is expected to handle cleanup of expired entries. All three callbacks can use only a session ID, and ignore the user ID that is passed in as well, because a session ID is a unique 128-bits binary by itself. However, not ignoring the user ID enables the use case where all sessions for a user are fetched or logged out, for example, so there are benefits to storing sessions per user. Reference Redis implementation (requires Redix and assumes a module has been configured for it according to its documentation): defmodule MyAppWeb.RedisSessionStore do @behaviour YipyipExAuth.SessionStore alias MyApp.MyRedix @key_prefix &quot;SESSION_STORE_&quot; @impl true def get ( session_id , user_id ) do [ &quot;GET&quot; , session_key ( session_id , user_id ) ] |&gt; MyRedix . command ( ) |&gt; case do { :ok , session } when not is_nil ( session ) -&gt; deserialize ( session ) { :ok , nil } -&gt; nil error -&gt; error end end @impl true def upsert ( %{ id : session_id , user_id : user_id } = session , ttl ) do [ &quot;SETEX&quot; , session_key ( session_id , user_id ) , Integer . to_string ( ttl ) , serialize ( session ) ] |&gt; MyRedix . command ( ) |&gt; case do { :ok , _ } -&gt; :ok error -&gt; error end end @impl true def delete ( session_id , user_id ) do [ &quot;DEL&quot; , session_key ( session_id , user_id ) ] |&gt; MyRedix . command ( ) |&gt; case do { :ok , _ } -&gt; :ok error -&gt; error end end def get_all ( user_id ) do with { :ok , keys } when keys != [ ] &lt;- find_session_keys ( user_id ) , { :ok , values } &lt;- MyRedix . command ( [ &quot;MGET&quot; | keys ] ) do Enum . map ( values , &amp; deserialize / 1 ) else { :ok , [ ] } -&gt; [ ] other -&gt; other end end def delete_all ( user_id ) do with { :ok , keys } when keys != [ ] &lt;- find_session_keys ( user_id ) , { :ok , _count } &lt;- MyRedix . command ( [ &quot;DEL&quot; | keys ] ) do :ok else { :ok , [ ] } -&gt; :ok other -&gt; other end end ##################### # Private functions # ##################### defp serialize ( session ) , do : :erlang . term_to_binary ( session ) defp deserialize ( binary ) , do : :erlang . binary_to_term ( binary ) # keys as IO lists to prevent unnecessary string concatenation overhead defp session_key ( session_id , user_id ) , do : [ @key_prefix , &quot;.&quot; , user_id , &quot;.&quot; , session_id ] # SCAN is not atomic. New sessions created during the scan may not be found. defp find_session_keys ( user_id , scan_iteration \\\\ nil , results \\\\ [ ] ) defp find_session_keys ( _user_id , &quot;0&quot; , results ) do { :ok , Enum . uniq ( results ) } end defp find_session_keys ( user_id , scan_iteration , results ) do [ &quot;SCAN&quot; , scan_iteration , &quot;MATCH&quot; , session_key ( &quot;*&quot; , user_id ) ] |&gt; MyRedix . command ( ) |&gt; case do { :ok , [ scan_iteration | [ partial_results ] ] } -&gt; find_session_keys ( user_id , scan_iteration , partial_results ++ results ) error -&gt; error end end end","ref":"YipyipExAuth.SessionStore.html","title":"YipyipExAuth.SessionStore","type":"behaviour"},{"doc":"Delete session with id session_id for user with id user_id . Implementations may choose to ignore user_id , since session_id is unique by itself.","ref":"YipyipExAuth.SessionStore.html#c:delete/2","title":"YipyipExAuth.SessionStore.delete/2","type":"callback"},{"doc":"Get session with id session_id for user with id user_id . Implementations may choose to ignore user_id , since session_id is unique by itself.","ref":"YipyipExAuth.SessionStore.html#c:get/2","title":"YipyipExAuth.SessionStore.get/2","type":"callback"},{"doc":"Insert or update Elixir.YipyipExAuth.Models.Session session , with time-to-live ttl . The session_id and user_id are taken from the session struct. Implementations may choose to ignore user_id , since session_id is unique by itself.","ref":"YipyipExAuth.SessionStore.html#c:upsert/2","title":"YipyipExAuth.SessionStore.upsert/2","type":"callback"},{"doc":"Helper functions for generating &quot;valid&quot; tokens for testing purposes. WARNING: These functions should not be called outside of tests.","ref":"YipyipExAuth.TestHelpers.html","title":"YipyipExAuth.TestHelpers","type":"module"},{"doc":"Generate an access token. Default payload can be overridden. The default payload is: %{ epl : %{ } , exp : nil , sid : &quot;a&quot; , tst : :bearer , uid : 1 }","ref":"YipyipExAuth.TestHelpers.html#generate_access_token/3","title":"YipyipExAuth.TestHelpers.generate_access_token/3","type":"function"},{"doc":"Generate a refresh token. Default payload can be overridden. The default payload is: %{ epl : %{ } , exp : nil , id : &quot;a&quot; , sid : &quot;a&quot; , tst : :bearer , uid : 1 }","ref":"YipyipExAuth.TestHelpers.html#generate_refresh_token/3","title":"YipyipExAuth.TestHelpers.generate_refresh_token/3","type":"function"},{"doc":"Sets request header &quot;authorization&quot; to &quot;Bearer access_token &quot;.","ref":"YipyipExAuth.TestHelpers.html#put_access_token/3","title":"YipyipExAuth.TestHelpers.put_access_token/3","type":"function"},{"doc":"Sets request header &quot;authorization&quot; to &quot;Bearer refresh_token &quot;.","ref":"YipyipExAuth.TestHelpers.html#put_refresh_token/3","title":"YipyipExAuth.TestHelpers.put_refresh_token/3","type":"function"},{"doc":"","ref":"YipyipExAuth.TestSupport.FakeEndpoint.html","title":"YipyipExAuth.TestSupport.FakeEndpoint","type":"module"},{"doc":"","ref":"YipyipExAuth.TestSupport.FakeEndpoint.html#config/1","title":"YipyipExAuth.TestSupport.FakeEndpoint.config/1","type":"function"},{"doc":"","ref":"YipyipExAuth.TestSupport.FakeSessionStore.html","title":"YipyipExAuth.TestSupport.FakeSessionStore","type":"module"},{"doc":"","ref":"YipyipExAuth.TestSupport.FakeSessionStore.html#delete/2","title":"YipyipExAuth.TestSupport.FakeSessionStore.delete/2","type":"function"},{"doc":"","ref":"YipyipExAuth.TestSupport.FakeSessionStore.html#get/2","title":"YipyipExAuth.TestSupport.FakeSessionStore.get/2","type":"function"},{"doc":"","ref":"YipyipExAuth.TestSupport.FakeSessionStore.html#upsert/2","title":"YipyipExAuth.TestSupport.FakeSessionStore.upsert/2","type":"function"},{"doc":"","ref":"YipyipExAuth.TestSupport.Shared.html","title":"YipyipExAuth.TestSupport.Shared","type":"module"},{"doc":"","ref":"YipyipExAuth.TestSupport.Shared.html#build_conn/0","title":"YipyipExAuth.TestSupport.Shared.build_conn/0","type":"function"},{"doc":"Utility functions, mainly getters and setters for module internals.","ref":"YipyipExAuth.Utils.html","title":"YipyipExAuth.Utils","type":"module"},{"doc":"Get access token payload, if present.","ref":"YipyipExAuth.Utils.html#get_access_token_payload/1","title":"YipyipExAuth.Utils.get_access_token_payload/1","type":"function"},{"doc":"Get auth error, if present.","ref":"YipyipExAuth.Utils.html#get_auth_error/1","title":"YipyipExAuth.Utils.get_auth_error/1","type":"function"},{"doc":"Get refresh token payload, if present.","ref":"YipyipExAuth.Utils.html#get_refresh_token_payload/1","title":"YipyipExAuth.Utils.get_refresh_token_payload/1","type":"function"},{"doc":"Get current session, if present.","ref":"YipyipExAuth.Utils.html#get_session/1","title":"YipyipExAuth.Utils.get_session/1","type":"function"},{"doc":"Get token signature transport mechanism, if present.","ref":"YipyipExAuth.Utils.html#get_token_signature_transport/1","title":"YipyipExAuth.Utils.get_token_signature_transport/1","type":"function"},{"doc":"Get tokens, if present.","ref":"YipyipExAuth.Utils.html#get_tokens/1","title":"YipyipExAuth.Utils.get_tokens/1","type":"function"},{"doc":"Get user id for session creation, if present.","ref":"YipyipExAuth.Utils.html#get_user_id/1","title":"YipyipExAuth.Utils.get_user_id/1","type":"function"},{"doc":"Set token signature transport mechanism. Must be one of &quot;bearer&quot; , &quot;cookie&quot; , :bearer or :cookie . Examples / doctests iex&gt; :bearer = % Conn { } |&gt; set_token_signature_transport ( &quot;bearer&quot; ) |&gt; get_token_signature_transport ( ) iex&gt; :bearer = % Conn { } |&gt; set_token_signature_transport ( :bearer ) |&gt; get_token_signature_transport ( ) iex&gt; :cookie = % Conn { } |&gt; set_token_signature_transport ( &quot;cookie&quot; ) |&gt; get_token_signature_transport ( ) iex&gt; :cookie = % Conn { } |&gt; set_token_signature_transport ( :cookie ) |&gt; get_token_signature_transport ( ) iex&gt; set_token_signature_transport ( % Conn { } , &quot;anything else&quot; ) ** (FunctionClauseError) no function clause matching in YipyipExAuth.Utils.set_token_signature_transport/2","ref":"YipyipExAuth.Utils.html#set_token_signature_transport/2","title":"YipyipExAuth.Utils.set_token_signature_transport/2","type":"function"},{"doc":"Set user id for session creation","ref":"YipyipExAuth.Utils.html#set_user_id/2","title":"YipyipExAuth.Utils.set_user_id/2","type":"function"},{"doc":"YipyipExAuth is an opinionated session manager for Elixir based on stateless access- and stateful refresh (Phoenix) tokens aimed at browser- and native clients that communicate with an Elixir API.","ref":"readme.html","title":"YipyipExAuth","type":"extras"},{"doc":"YipyipExAuth Table of contents What the package does Problems solved Problems NOT (attempted to be) solved The slightly longer story How to use Installation Configuration Setting up a session store Protecting routes Creating and refreshing sessions Documentation Nods","ref":"readme.html#table-of-contents","title":"YipyipExAuth - Table of contents","type":"extras"},{"doc":"Problems solved This package attempts to solve the following issues: tokens in LocalStorage are less secure than cookies, given that CSRF can be protected against quite well cookies are limited to 4kB native clients don't like cookies and just want to use tokens stateless tokens are nice for performance but without tracking any server-side sessions, it is impossible to force a logout Problems NOT (attempted to be) solved This package aims to be (and remain) small. It depends only on Phoenix. Also, we like our flexibility. The following things are left up to the application: user management, registration, password change, confirmation emails etc authentication mechanisms like passwords, one-time passwords, etc authorization mechanisms like definining roles etc CSRF-protection This package DOES lay the groundwork for you to add those things.","ref":"readme.html#what-the-package-does","title":"YipyipExAuth - What the package does","type":"extras"},{"doc":"A great many solutions exist for generating tokens to use in API authentication. Not many of these implementations really concern themselves with the security of said tokens in a browser contex; the tokens are sent on their way for the client to deal with. Especially the practice of storing authentication tokens in LocalStorage where they are vulnerable to cross-site scripting (XSS) attack vectors is something that this package tries to tackle. At the same time, cookies have their own drawbacks as well; they max out at 4KB and are vulnerable to cross-site request forgery (CSRF). On top of that native clients don't want to deal with cookies, they just want to shove a bearer token into the authorization header and be done with it. This package is an attempt to have our cake and eat it at the same time, by splitting authentication tokens in two parts. Phoenix tokens (and JWT's) consist of three parts, basically header.payload.signature . The first two parts are not valid without the signature, and the signature is impossible to generate from the first two parts without the underlying signing key thanks to CryptographyTM. YipyipExAuth allows clients to specify at the creation of a session if they want to receive the signature part of their tokens in a secure, HTTP-only strictly-same-site cookie, or simply as part of the the whole token. Browser clients should use the former, native clients the latter. In case of a successful XSS breach of the web application only the token payloads will be exposed. Additionally, YipyipExAuth tries to strike a balance between statelessness and security, by using stateless short-lived access tokens and stateful refresh tokens. A server-side session store is maintained (and can be implemented in whatever DB system you like; genserver, Redis, Postgres or Mnesia can all be used by implementing a simple behaviour). Every time the tokens are refreshed, this database is queried. Depending on your access token TTL, this could be once every half an hour per client. By the time you outgrow a simple Redis cluster, you can hire a team of engineers to scale further.","ref":"readme.html#the-slightly-longer-story","title":"YipyipExAuth - The slightly longer story","type":"extras"},{"doc":"Getting up and running consists of 5 steps: installation, configuration, setting up a session store, protecting your routes and handing out tokens. Installation The package can be installed by adding yipyip_ex_auth to your list of dependencies in mix.exs : def deps do [ { :yipyip_ex_auth , &quot;0.3.0-alpha.1&quot; } ] end Configuration Configuration has been made easy using a config helper struct YipyipExAuth.Config , which has a function from_enum/1 that verifies that your config is complete and valid, raising on missing fields. You can create this struct at runtime or compile time or change it dynamically however you please, but bear in mind that you might run into problems if you use different values for different parts of YipyipExAuth . The main reason to use multiple sets of configuration is that you can support different auth requirements in this way. You could, for example, create a never-expiring session for ordinary users and create a short-lived session for application admins. # all other configuration uses sane defaults # the following sets up sessions that last forever as long as they are used at least once a month @my_config YipyipExAuth.Config . from_enum ( session_ttl : nil , refresh_token_ttl : 30 * 24 * 60 * 60 , session_store_module : MySessionStoreModule ) # you can also directly pass in your application environment @my_config Application . compile_env ( :my_phoenix_app , :yipyip_ex_auth ) |&gt; YipyipExAuth.Config . from_enum ( ) Setting up a session store A session store can be created using multiple state stores, be it a database or a GenServer. All you have to do is implement a simple behaviour which you can find in YipyipExAuth.SessionStore . We've also provided a reference Redis-based implementation there that we find easy to work with and deploy. Protecting routes In the router of your Phoenix application, create pipelines to protect routes with either access- or refresh tokens, using YipyipExAuth.Plugs.ProcessAccessToken and YipyipExAuth.Plugs.ProcessRefreshToken , plus a custom plug to send auth errors back to the client. In this case, it's just been added to the router itself, which is not very tidy but demonstrates the basic idea. defmodule MyPhoenixAppWeb.Router do use MyPhoenixAppWeb , :router @config Application . compile_env ( :my_phoenix_app , :yipyip_ex_auth ) |&gt; YipyipExAuth.Config . from_enum ( ) pipeline :valid_access_token do plug YipyipExAuth.Plugs.ProcessAccessToken , @config plug :only_authenticated end pipeline :valid_refresh_token do plug YipyipExAuth.Plugs.ProcessRefreshToken , @config plug :only_authenticated end @doc &quot;&quot;&quot; Reject unauthenticated requests &quot;&quot;&quot; def only_authenticated ( %{ assigns : %{ current_user_id : _ } } = conn , _opts ) , do : conn def only_authenticated ( conn , _opts ) do auth_error = YipyipExAuth.Utils . get_auth_error ( conn ) conn |&gt; Plug.Conn . send_resp ( 401 , auth_error ) |&gt; halt ( ) end end Then you should protect your refresh route with the refresh pipeline and standard authenticated-only routes with the access token pipeline (among which is the delete session / logout endpoint). The login endpoint should be kept unprotected, naturally. scope &quot;/&quot; do pipe_through [ :api ] post &quot;/current_session&quot; , CurrentSessionController , :create end scope &quot;/&quot; do pipe_through [ :api , :valid_access_token ] resources &quot;/articles&quot; , ArticleController , only : [ :index , :show ] delete &quot;/current_session&quot; , CurrentSessionController , :delete end scope &quot;/&quot; do pipe_through [ :api , :valid_refresh_token ] # optionally limit the refresh cookie path to this path using `Config.refresh_cookie_opts` post &quot;/current_session/refresh&quot; , CurrentSessionController , :refresh end And that's it. Creating and refreshing sessions Create a session controller with at least login, logout and refresh routes. defmodule MyPhoenixAppWeb.CurrentSessionController do @moduledoc &quot;&quot;&quot; REST controller for the current session. For details on how sessions work, please refer to `YipyipExAuth`. &quot;&quot;&quot; use MyPhoenixAppWeb , :controller alias YipyipExAuth.Plugs , as : YipyipPlugs alias YipyipExAuth.Utils alias MyPhoenixApp . { User , Users } @config Application . compile_env ( :my_phoenix_app , :yipyip_ex_auth ) |&gt; YipyipExAuth.Config . from_enum ( ) @doc &quot;&quot;&quot; Create a new session / login. Returns the user, session and access- and refresh tokens. If &quot;token_signature_transport&quot; is set to &quot;bearer&quot;, the tokens returned in the response body will include the signatures needed to verify their integrity. If it is set to &quot;cookie&quot;, those signatures will be returned as cookies. Returns: - 201 Created and session and tokens and maybe cookie - 400 Bad Request and errors if request body is malformed - 401 Unauthorized and errors if the request could not be authenticated or the user was not found - 500 Internal Server Error and errors if an unforeseen error occurred &quot;&quot;&quot; @spec create ( Plug.Conn . t ( ) , map ( ) ) :: Plug.Conn . t ( ) def create ( conn , %{ &quot;email&quot; =&gt; email , &quot;password&quot; =&gt; password , &quot;token_signature_transport&quot; =&gt; signature_transport } ) when signature_transport in ~w(bearer cookie) do with { :ok , user } &lt;- Users . get_by ( email : email ) |&gt; Users . verify_password ( password ) do # you can do extra checks here, like checking if the user is banned, for example conn |&gt; Utils . set_user_id ( user . id ) |&gt; Utils . set_token_signature_transport ( signature_transport ) # you can add extra payload to the tokens |&gt; YipyipPlugs . create_session ( @config , %{ roles : user . roles } , %{ } ) |&gt; put_status ( 201 ) |&gt; send_token_response ( user ) else _error -&gt; send_resp ( conn , 401 , &quot;user not found or wrong password&quot; ) end end @doc &quot;&quot;&quot; Delete current session / logout. Requires authentication. Will remove the server-side session and instructs browser clients to drop the token signature cookies set by `YipyipExAuth`. Note that this cannot be enforced from the server side - clients are responsible for correct disposal of authentication tokens themselves. Returns: - 204 No Content - 401 Unauthorized and errors if the request could not be authenticated - 500 Internal Server Error and errors if an unforeseen error occurred &quot;&quot;&quot; @spec delete ( Plug.Conn . t ( ) , map ( ) ) :: Plug.Conn . t ( ) def delete ( conn , _params ) do conn |&gt; YipyipPlugs . delete_session ( @config ) |&gt; send_resp ( 204 , &quot;&quot; ) end @doc &quot;&quot;&quot; Refresh an existing session. Requires authentication in the form of a single-use refresh token. Returns: - 200 OK and session and tokens and maybe cookie - 401 Unauthorized and errors if the request could not be authenticated - 500 Internal Server Error and errors if an unforeseen error occurred &quot;&quot;&quot; @spec refresh ( Plug.Conn . t ( ) , map ( ) ) :: Plug.Conn . t ( ) def refresh ( %{ assigns : %{ current_user_id : user_id } } = conn , _params ) do with % User { } = user &lt;- Users . get_by ( id : user_id ) do # here you can do extra checks again # for example if the user has been banned since the previous refresh conn # there&#39;s no need to set user_id or token signature transport again |&gt; YipyipPlugs . create_session ( @config , %{ roles : user . roles } , %{ } ) |&gt; send_token_response ( user ) else _error -&gt; send_resp ( conn , 401 , &quot;user not found or inactive&quot; ) end end ############ # Privates # ############ defp send_token_response ( conn , user ) do session = Utils . get_session ( conn ) tokens = Utils . get_tokens ( conn ) render ( conn , &quot;tokens.json&quot; , tokens : tokens , session : session , user : user ) end end","ref":"readme.html#how-to-use","title":"YipyipExAuth - How to use","type":"extras"},{"doc":"Documentation can be found at https://hexdocs.pm/yipyip_ex_auth .","ref":"readme.html#documentation","title":"YipyipExAuth - Documentation","type":"extras"},{"doc":"The idea of splitting of the token signature is inspired by this excellent Medium article by Peter Locke. The ideas of passing around a config parameter, splitting token processing and error handling, depending on as little as possible, separating the persistent session store and general token handling were inspired by Pow by Dan Schultzer, which is an excellent alternative if you don't want to solve the problems named under problems not attempted to be solved , or for working with Phoenix templates.","ref":"readme.html#nods","title":"YipyipExAuth - Nods","type":"extras"}]